﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.IO.Pipes;
using System.Security.Principal;
using RTedge;   // RT-edge system API



namespace EgWebClr
{
    public partial class EgWeb_API
    {
        static edge_API EGAPI = new edge_API();        //APIの宣言
        // イニシャル済み　：　1
        public struct TagRef
        {
            public string Name;         //名称
            public ushort Size;         //サイズ
            public ushort Type;         //データの型
            public string Address;      //アドレス指定
        }
        //xml記載済みの参照Tagリスト
        public static List<TagRef> tagRef_IN_List = new List<TagRef>();
        public static List<TagRef> tagRef_OUT_List = new List<TagRef>();
        public static List<TagRef> tagRef_CNTL_List = new List<TagRef>();
        /// <summary>
        /// <returns></returns>
        public static int EgWebInit()
        {
            //pipeでサーバーと通信する
            int ists = CreateClientTask("EdgeWebPipe");

            if (ists == 1)
            { return 0; }
            else { return -1; }
        }

        /// <summary>
        /// <param name="sttagname></param>
        /// <param name="obdata></param>
        /// <returns></returns>
        public static int EgWebPageCount()
        {
            //APIの戻り値の変数
            int ians = 0;
            //APIの結果取得変数
            object value = new object();
            string sttagname = "SERVICE.EgWebSvr.PageOpenCnt";
            try
            {
                //APIでValue値を読み込む
                ians = EGAPI.EgTagRead(sttagname, ref value);
                if (ians == 0)
                {
                    UInt32 Val = UInt32.Parse(value.ToString());
                    Val++;
                    //APIでValue値を書き込む
                    ians = EGAPI.EgTagWrite(sttagname, Val);

                }
            }
            catch (Exception e)
            {
                // 送信失敗
                Console.WriteLine(e.Message);
                ians = -1;
            }

            return ians;
        }



        /// <summary>
        /// <param name="pipeName></param>
        private static int  CreateClientTask(string pipeName)
        {
            int ists = 0;
            TagRef wkTag = new TagRef();
            NamedPipeClientStream pipeClient = null;
            try
            {
                pipeClient = new NamedPipeClientStream(".", pipeName, PipeDirection.InOut, PipeOptions.None, TokenImpersonationLevel.Impersonation);
                pipeClient.Connect(1000);
                var ss = new StreamString(pipeClient);

                // 入力された文字列を送信する
                var writeData = "TagRef_IN";
                var write = ss.WriteString(writeData);

                // 応答待ち
                string read = ss.ReadString();
                int i = 0;
                string[] arr = read.Split(',');

                // 配列に格納したデータを出力する
                //foreach (var s in arr)
                //{

                //    if (i == 0) { wkTag.Name = s; }
                //    if (i == 1) { wkTag.Type = ushort.Parse(s); }
                //    if (i == 2) { wkTag.Size = ushort.Parse(s); }
                //    if (i == 3) { wkTag.Address = s; }
                //    if (i == 3)
                //    {
                //        tagRef_IN_List.Add(wkTag);
                //        i = 0;
                //    }
                //    else { i++; }
                //}

                foreach (var s in arr)
                {

                    if (i == 0) { wkTag.Name = s; }
                    if (i == 1) { wkTag.Type = ushort.Parse(s); }
                    if (i == 2) { wkTag.Size = ushort.Parse(s); }
                    if (i == 3) { wkTag.Address = s; }
                    if (i == 3)
                    {
                        tagRef_IN_List.Add(wkTag);
                        i = 0;
                    }
                    else { i++; }
                }


                //wkTag.Name = "a";
                //wkTag.Type = 1;
                //wkTag.Size = 2;
                //wkTag.Address = "b";
                
                ////TagRef item = new TagRef(wkTag.Name, wkTag.Type, wkTag.Size, wkTag.Address);
                //tagRef_IN_List.Add(wkTag);



                // 入力された文字列を送信する
                writeData = "TagRef_OUT";
                write = ss.WriteString(writeData);
                // 応答待ち
                read = ss.ReadString();
                i = 0;
                arr = read.Split(',');

                // 配列に格納したデータを出力する
                foreach (var s in arr)
                {

                    if (i == 0) { wkTag.Name = s; }
                    if (i == 1) { wkTag.Type = ushort.Parse(s); }
                    if (i == 2) { wkTag.Size = ushort.Parse(s); }
                    if (i == 3) { wkTag.Address = s; }
                    if (i == 3)
                    {
                        tagRef_OUT_List.Add(wkTag);
                        i = 0;
                    }
                    else { i++; }
                }


                // 入力された文字列を送信する
                writeData = "TagRef_SYS";
                write = ss.WriteString(writeData);
                // 応答待ち
                read = ss.ReadString();
                if (read != "")
                { ists = 1; }

                i = 0;
                arr = read.Split(',');
                // 配列に格納したデータを出力する
                foreach (var s in arr)
                {

                    if (i == 0) { wkTag.Name = s; }
                    if (i == 1) { wkTag.Type = ushort.Parse(s); }
                    if (i == 2) { wkTag.Size = ushort.Parse(s); }
                    if (i == 3) { wkTag.Address = s; }
                    if (i == 3)
                    {
                        tagRef_CNTL_List.Add(wkTag);
                        i = 0;
                    }
                    else { i++; }
                }



            }
            catch (OverflowException ofex)
            {
                Console.WriteLine(ofex.Message);
            }
            catch (IOException ioe)
            {
                // 送信失敗
                Console.WriteLine(ioe.Message);
            }
            finally
            {
                pipeClient?.Close();
            }

            return ists;
        }
        // (streamに文字列を読み書きしてくれるクラス)
        private class StreamString
        {
            private Stream ioStream;
            private UTF8Encoding streamEncoding;

            public StreamString(Stream ioStream)
            {
                this.ioStream = ioStream;
                streamEncoding = new UTF8Encoding();
            }

            public string ReadString()
            {
                int len = 0;

                len = ioStream.ReadByte() * 256;
                len += ioStream.ReadByte();
                byte[] inBuffer = new byte[len];
                ioStream.Read(inBuffer, 0, len);

                return streamEncoding.GetString(inBuffer);
            }



            public int WriteString(string outString)
            {
                byte[] outBuffer = streamEncoding.GetBytes(outString);
                int len = outBuffer.Length;
                if (len > UInt16.MaxValue)
                {
                    len = (int)UInt16.MaxValue;
                }
                ioStream.WriteByte((byte)(len / 256));
                ioStream.WriteByte((byte)(len & 255));
                ioStream.Write(outBuffer, 0, len);
                ioStream.Flush();

                return outBuffer.Length + 2;
            }



        }



    }
}
