﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
using RTedge;
using System;

/// <summary>
/// --------------------------------------------------------------------------
///   RT-edge system / Container
/// 
///   EgMC.exe(W)
///       OMROM PLC series data connector service
/// 
///   Copyright(c) Micronet Corp 2022, Programmed by Kazumi.M
/// 
/// 
///   -OMRON PLC data output functions
///   
/// --------------------------------------------------------------------------
/// </summary>

namespace EgWebSvr
{
    /// <summary>
    /// サービス本体
    /// </summary>
    public partial class EdgeService
    {
        /// <summary>
        /// ターゲットOutputPLCのリストアップ処理、TagRefInの解釈
        /// </summary>
        /// <returns></returns>
        string  TargetPlcOutputListup()
        {

            object value = new object();
            string stans = "";
            string stCNV = "";
            int ret = 0;
            // TagRefリスト参照
            for (var i = 0; i < EGAPI.EGFW.tagRef_OUT_List.Count; i++)
            {
                var tagrefitem = EGAPI.EGFW.tagRef_OUT_List[i];

                try
                {
                    ret = EGAPI.EgTagRead(tagrefitem.Name, ref value);
                    //存在しないタグは無視
                    if (ret == 0)
                    {
                        ret = tagrefitem.Name.IndexOf(",") + 1;
                        if (ret == 0)
                        {
                            if (stans == "")
                            {
                                stans = tagrefitem.Name;
                            }
                            else
                            {
                                stans = stans + "," + tagrefitem.Name;
                            }
                            stans = stans + "," + tagrefitem.Type.ToString();
                            stans = stans + "," + tagrefitem.Size.ToString();
                            ret = tagrefitem.Address.IndexOf(",") + 1;
                            if (ret == 0)
                            {
                                stans = stans + "," + tagrefitem.Address;
                            }
                            else
                            {
                                stans = stans + "," + tagrefitem.Address.Replace(",", "");
                                stCNV = tagrefitem.Address.Replace(",", "");
                                stCNV = stCNV.Replace("%", "%%");

                                edge_FW._PrintSysLog(GetServiceName(), "WARN", String.Format("TagRefs_OUT Address='{0}' is not exist, Ignored", stCNV));
                            }
                        }
                        else
                        {
                            stCNV = tagrefitem.Name.Replace(",", "");
                            stCNV = stCNV.Replace("%", "%%");
                            edge_FW._PrintSysLog(GetServiceName(), "ERR", "tagRef_OUT name err " + stCNV);
                            GB_err = 1;
                        }
                    }
                    else
                    {
                        stCNV = tagrefitem.Name.Replace(",", "");
                        stCNV = stCNV.Replace("%", "%%");
                        edge_FW._PrintSysLog(GetServiceName(), "WARN", String.Format("TagRefs_OUT Name='{0}' is not exist, Ignored", stCNV));
                    }
                }
                catch(Exception ex)
                {
                    edge_FW._PrintSysLog(GetServiceName(), "ERR", "tagRef_OUT name err " + ex.ToString());
                    GB_err = 1;
                }

            }
            return stans;


        }

    }
}
